AUTOFADE
from Your Sinclair #4 (Apr.1986)
by Andrew Pennell


Pass 1 errors: 00

              ;AutoFade routine
              ;(c) A.Pennell 1985
0001          FLAGS  EQU  1
FAC7                 ORG 64199
              ;screen buffer
FAC7          SCRBUF DEFS 768
              ;
              ;initialisation routine
FDC7 2100FE   INIT   LD   HL,#FE00
FDCA 0600            LD   B,0
FDCC F3              DI
              ;set up int table
FDCD 36FD     INITLP LD   (HL),#FD
FDCF 23              INC  HL
FDD0 10FB            DJNZ INITLP
FDD2 36FD            LD   (HL),#FD
FDD4 3EFE            LD   A,#FE
FDD6 ED47            LD   I,A
FDD8 ED5E            IM   2
FDDA FB              EI
FDDB 210100          LD   HL,1
FDDE 22FBFD          LD   (TIMER),HL
FDE1 C9              RET
              ;disable fader
FDE2 ED56     DISFAD IM   1
FDE4 C9              RET
              ;the interrupt handler
FDE5 FF       INTROU RST  #38  ;call ROM
FDE6 F3              DI
FDE7 F5              PUSH AF
FDE8 E5              PUSH HL
FDE9 C5              PUSH BC
FDEA D5               PUSH DE
FDEB ED5BFBFD        LD   DE,(TIMER)
FDEF CD01FF          CALL MYINT
FDF2 22FBFD          LD   (TIMER),HL
FDF5 D1              POP  DE
FDF6 C1              POP  BC
FDF7 E1              POP  HL
FDF8 F1              POP  AF
FDF9 FB              EI
FDFA C9             RET
FDFB 0100     TIMER  DEFW 1
              ;this must be at #FDFD
FDFD C3E5FD          JP   INTROU
              ;and this is #FE00
FE00          LFE00  DEFS 257

              ;special interrupt routine
FF01 7A       MYINT  LD   A,D
FF02 B3              OR   E
FF03 2832            JR   Z,TISBLA ;if already off
FF05 21E803          LD   HL,20*50 ;I like 20 secs
FF08 A7              AND  A
FF09 ED52            SBC  HL,DE
FF0B 280B            JR   Z,BLANK  ;if timed out
FF0D EB              EX   DE,HL
FF0E 23              INC  HL
FF0F FDCB016E        BIT  5,(IY+FLAGS)
FF13 C8              RET  Z        ;if no key
              ;a key was pressed so clear counter
FF14 210100          LD   HL,1
FF17 C9              RET

              ;it's timed out
FF18 210058   BLANK  LD   HL,#5800
FF1B 11C7FA          LD   DE,SCRBUF
FF1E 010003          LD   BC,768
FF21 7E       SVLP   LD   A,(HL)
FF22 12              LD   (DE),A   ;copy to buffer
FF23 3600            LD   (HL),0   ;clear to black
FF25 23              INC  HL
FF26 13              INC  DE
FF27 0B              DEC  BC
FF28 7B              LD   A,B
FF29 B1              OR   C
FF2A 20F5            JR   NZ,SVLP
FF2C D3FE            OUT  (#FE),A  ;black border
FF2E 3ED8            LD   A,%10111000
FF30 32FF5A          LD   (#5AFF),A ;cursor
FF33 210000          LD   HL,0
FF36 C9              RET

              ;I'm blank so see if key
FF37 EB       TISBLA EX   DE,HL
FF38 FDCB016E        BIT  5,(IY+FLAGS)
FF3C C8              RET Z         ;if no key
              ;restore display
FF3D 21C7FA          LD   HL,SCRBUF
FF40 110058          LD   DE,#5800
FF43 010003          LD   BC,768
FF46 EDB0            LDIR
FF48 3A485C          LD   A,(23624)
FF4B E638            AND  #38
FF4D 0F              RRCA
FF4E 0F              RRCA
FF4F 0F              RRCA
FF50 D3FE            OUT  (#FE),A
FF52 210100          LD   HL,1
FF55 C9              RET

Pass 2 errors: 00

Table used:   160  from   284


--
Another Fine Product transcribed by:
Jim Grimwood (jimg@globalnet.co.uk), Weardale, England
--
